-- Do not manually edit this file, it was auto-generated by Graphqelm
-- https://github.com/dillonkearns/graphqelm


module Github.Mutation exposing (..)

import Github.InputObject
import Github.Interface
import Github.Object
import Github.Scalar
import Github.Union
import Graphqelm.Field as Field exposing (Field)
import Graphqelm.Internal.Builder.Argument as Argument exposing (Argument)
import Graphqelm.Internal.Builder.Object as Object
import Graphqelm.Internal.Encode as Encode exposing (Value)
import Graphqelm.Operation exposing (RootMutation)
import Graphqelm.OptionalArgument exposing (OptionalArgument(Absent))
import Graphqelm.SelectionSet exposing (SelectionSet)
import Json.Decode as Decode exposing (Decoder)


{-| Select fields to build up a top-level mutation. The request can be sent with
functions from `Graphqelm.Http`.
-}
selection : (a -> constructor) -> SelectionSet (a -> constructor) RootMutation
selection constructor =
    Object.selection constructor


{-| Applies a suggested topic to the repository.
-}
acceptTopicSuggestion : { input : Github.InputObject.AcceptTopicSuggestionInput } -> SelectionSet decodesTo Github.Object.AcceptTopicSuggestionPayload -> Field (Maybe decodesTo) RootMutation
acceptTopicSuggestion requiredArgs object =
    Object.selectionField "acceptTopicSuggestion" [ Argument.required "input" requiredArgs.input Github.InputObject.encodeAcceptTopicSuggestionInput ] object (identity >> Decode.nullable)


{-| Adds a comment to an Issue or Pull Request.
-}
addComment : { input : Github.InputObject.AddCommentInput } -> SelectionSet decodesTo Github.Object.AddCommentPayload -> Field (Maybe decodesTo) RootMutation
addComment requiredArgs object =
    Object.selectionField "addComment" [ Argument.required "input" requiredArgs.input Github.InputObject.encodeAddCommentInput ] object (identity >> Decode.nullable)


{-| Adds a card to a ProjectColumn. Either `contentId` or `note` must be provided but **not** both.
-}
addProjectCard : { input : Github.InputObject.AddProjectCardInput } -> SelectionSet decodesTo Github.Object.AddProjectCardPayload -> Field (Maybe decodesTo) RootMutation
addProjectCard requiredArgs object =
    Object.selectionField "addProjectCard" [ Argument.required "input" requiredArgs.input Github.InputObject.encodeAddProjectCardInput ] object (identity >> Decode.nullable)


{-| Adds a column to a Project.
-}
addProjectColumn : { input : Github.InputObject.AddProjectColumnInput } -> SelectionSet decodesTo Github.Object.AddProjectColumnPayload -> Field (Maybe decodesTo) RootMutation
addProjectColumn requiredArgs object =
    Object.selectionField "addProjectColumn" [ Argument.required "input" requiredArgs.input Github.InputObject.encodeAddProjectColumnInput ] object (identity >> Decode.nullable)


{-| Adds a review to a Pull Request.
-}
addPullRequestReview : { input : Github.InputObject.AddPullRequestReviewInput } -> SelectionSet decodesTo Github.Object.AddPullRequestReviewPayload -> Field (Maybe decodesTo) RootMutation
addPullRequestReview requiredArgs object =
    Object.selectionField "addPullRequestReview" [ Argument.required "input" requiredArgs.input Github.InputObject.encodeAddPullRequestReviewInput ] object (identity >> Decode.nullable)


{-| Adds a comment to a review.
-}
addPullRequestReviewComment : { input : Github.InputObject.AddPullRequestReviewCommentInput } -> SelectionSet decodesTo Github.Object.AddPullRequestReviewCommentPayload -> Field (Maybe decodesTo) RootMutation
addPullRequestReviewComment requiredArgs object =
    Object.selectionField "addPullRequestReviewComment" [ Argument.required "input" requiredArgs.input Github.InputObject.encodeAddPullRequestReviewCommentInput ] object (identity >> Decode.nullable)


{-| Adds a reaction to a subject.
-}
addReaction : { input : Github.InputObject.AddReactionInput } -> SelectionSet decodesTo Github.Object.AddReactionPayload -> Field (Maybe decodesTo) RootMutation
addReaction requiredArgs object =
    Object.selectionField "addReaction" [ Argument.required "input" requiredArgs.input Github.InputObject.encodeAddReactionInput ] object (identity >> Decode.nullable)


{-| Adds a star to a Starrable.
-}
addStar : { input : Github.InputObject.AddStarInput } -> SelectionSet decodesTo Github.Object.AddStarPayload -> Field (Maybe decodesTo) RootMutation
addStar requiredArgs object =
    Object.selectionField "addStar" [ Argument.required "input" requiredArgs.input Github.InputObject.encodeAddStarInput ] object (identity >> Decode.nullable)


{-| Creates a new project.
-}
createProject : { input : Github.InputObject.CreateProjectInput } -> SelectionSet decodesTo Github.Object.CreateProjectPayload -> Field (Maybe decodesTo) RootMutation
createProject requiredArgs object =
    Object.selectionField "createProject" [ Argument.required "input" requiredArgs.input Github.InputObject.encodeCreateProjectInput ] object (identity >> Decode.nullable)


{-| Rejects a suggested topic for the repository.
-}
declineTopicSuggestion : { input : Github.InputObject.DeclineTopicSuggestionInput } -> SelectionSet decodesTo Github.Object.DeclineTopicSuggestionPayload -> Field (Maybe decodesTo) RootMutation
declineTopicSuggestion requiredArgs object =
    Object.selectionField "declineTopicSuggestion" [ Argument.required "input" requiredArgs.input Github.InputObject.encodeDeclineTopicSuggestionInput ] object (identity >> Decode.nullable)


{-| Deletes a project.
-}
deleteProject : { input : Github.InputObject.DeleteProjectInput } -> SelectionSet decodesTo Github.Object.DeleteProjectPayload -> Field (Maybe decodesTo) RootMutation
deleteProject requiredArgs object =
    Object.selectionField "deleteProject" [ Argument.required "input" requiredArgs.input Github.InputObject.encodeDeleteProjectInput ] object (identity >> Decode.nullable)


{-| Deletes a project card.
-}
deleteProjectCard : { input : Github.InputObject.DeleteProjectCardInput } -> SelectionSet decodesTo Github.Object.DeleteProjectCardPayload -> Field (Maybe decodesTo) RootMutation
deleteProjectCard requiredArgs object =
    Object.selectionField "deleteProjectCard" [ Argument.required "input" requiredArgs.input Github.InputObject.encodeDeleteProjectCardInput ] object (identity >> Decode.nullable)


{-| Deletes a project column.
-}
deleteProjectColumn : { input : Github.InputObject.DeleteProjectColumnInput } -> SelectionSet decodesTo Github.Object.DeleteProjectColumnPayload -> Field (Maybe decodesTo) RootMutation
deleteProjectColumn requiredArgs object =
    Object.selectionField "deleteProjectColumn" [ Argument.required "input" requiredArgs.input Github.InputObject.encodeDeleteProjectColumnInput ] object (identity >> Decode.nullable)


{-| Deletes a pull request review.
-}
deletePullRequestReview : { input : Github.InputObject.DeletePullRequestReviewInput } -> SelectionSet decodesTo Github.Object.DeletePullRequestReviewPayload -> Field (Maybe decodesTo) RootMutation
deletePullRequestReview requiredArgs object =
    Object.selectionField "deletePullRequestReview" [ Argument.required "input" requiredArgs.input Github.InputObject.encodeDeletePullRequestReviewInput ] object (identity >> Decode.nullable)


{-| Dismisses an approved or rejected pull request review.
-}
dismissPullRequestReview : { input : Github.InputObject.DismissPullRequestReviewInput } -> SelectionSet decodesTo Github.Object.DismissPullRequestReviewPayload -> Field (Maybe decodesTo) RootMutation
dismissPullRequestReview requiredArgs object =
    Object.selectionField "dismissPullRequestReview" [ Argument.required "input" requiredArgs.input Github.InputObject.encodeDismissPullRequestReviewInput ] object (identity >> Decode.nullable)


{-| Lock a lockable object
-}
lockLockable : { input : Github.InputObject.LockLockableInput } -> SelectionSet decodesTo Github.Object.LockLockablePayload -> Field (Maybe decodesTo) RootMutation
lockLockable requiredArgs object =
    Object.selectionField "lockLockable" [ Argument.required "input" requiredArgs.input Github.InputObject.encodeLockLockableInput ] object (identity >> Decode.nullable)


{-| Moves a project card to another place.
-}
moveProjectCard : { input : Github.InputObject.MoveProjectCardInput } -> SelectionSet decodesTo Github.Object.MoveProjectCardPayload -> Field (Maybe decodesTo) RootMutation
moveProjectCard requiredArgs object =
    Object.selectionField "moveProjectCard" [ Argument.required "input" requiredArgs.input Github.InputObject.encodeMoveProjectCardInput ] object (identity >> Decode.nullable)


{-| Moves a project column to another place.
-}
moveProjectColumn : { input : Github.InputObject.MoveProjectColumnInput } -> SelectionSet decodesTo Github.Object.MoveProjectColumnPayload -> Field (Maybe decodesTo) RootMutation
moveProjectColumn requiredArgs object =
    Object.selectionField "moveProjectColumn" [ Argument.required "input" requiredArgs.input Github.InputObject.encodeMoveProjectColumnInput ] object (identity >> Decode.nullable)


{-| Removes outside collaborator from all repositories in an organization.
-}
removeOutsideCollaborator : { input : Github.InputObject.RemoveOutsideCollaboratorInput } -> SelectionSet decodesTo Github.Object.RemoveOutsideCollaboratorPayload -> Field (Maybe decodesTo) RootMutation
removeOutsideCollaborator requiredArgs object =
    Object.selectionField "removeOutsideCollaborator" [ Argument.required "input" requiredArgs.input Github.InputObject.encodeRemoveOutsideCollaboratorInput ] object (identity >> Decode.nullable)


{-| Removes a reaction from a subject.
-}
removeReaction : { input : Github.InputObject.RemoveReactionInput } -> SelectionSet decodesTo Github.Object.RemoveReactionPayload -> Field (Maybe decodesTo) RootMutation
removeReaction requiredArgs object =
    Object.selectionField "removeReaction" [ Argument.required "input" requiredArgs.input Github.InputObject.encodeRemoveReactionInput ] object (identity >> Decode.nullable)


{-| Removes a star from a Starrable.
-}
removeStar : { input : Github.InputObject.RemoveStarInput } -> SelectionSet decodesTo Github.Object.RemoveStarPayload -> Field (Maybe decodesTo) RootMutation
removeStar requiredArgs object =
    Object.selectionField "removeStar" [ Argument.required "input" requiredArgs.input Github.InputObject.encodeRemoveStarInput ] object (identity >> Decode.nullable)


{-| Set review requests on a pull request.
-}
requestReviews : { input : Github.InputObject.RequestReviewsInput } -> SelectionSet decodesTo Github.Object.RequestReviewsPayload -> Field (Maybe decodesTo) RootMutation
requestReviews requiredArgs object =
    Object.selectionField "requestReviews" [ Argument.required "input" requiredArgs.input Github.InputObject.encodeRequestReviewsInput ] object (identity >> Decode.nullable)


{-| Submits a pending pull request review.
-}
submitPullRequestReview : { input : Github.InputObject.SubmitPullRequestReviewInput } -> SelectionSet decodesTo Github.Object.SubmitPullRequestReviewPayload -> Field (Maybe decodesTo) RootMutation
submitPullRequestReview requiredArgs object =
    Object.selectionField "submitPullRequestReview" [ Argument.required "input" requiredArgs.input Github.InputObject.encodeSubmitPullRequestReviewInput ] object (identity >> Decode.nullable)


{-| Updates an existing project.
-}
updateProject : { input : Github.InputObject.UpdateProjectInput } -> SelectionSet decodesTo Github.Object.UpdateProjectPayload -> Field (Maybe decodesTo) RootMutation
updateProject requiredArgs object =
    Object.selectionField "updateProject" [ Argument.required "input" requiredArgs.input Github.InputObject.encodeUpdateProjectInput ] object (identity >> Decode.nullable)


{-| Updates an existing project card.
-}
updateProjectCard : { input : Github.InputObject.UpdateProjectCardInput } -> SelectionSet decodesTo Github.Object.UpdateProjectCardPayload -> Field (Maybe decodesTo) RootMutation
updateProjectCard requiredArgs object =
    Object.selectionField "updateProjectCard" [ Argument.required "input" requiredArgs.input Github.InputObject.encodeUpdateProjectCardInput ] object (identity >> Decode.nullable)


{-| Updates an existing project column.
-}
updateProjectColumn : { input : Github.InputObject.UpdateProjectColumnInput } -> SelectionSet decodesTo Github.Object.UpdateProjectColumnPayload -> Field (Maybe decodesTo) RootMutation
updateProjectColumn requiredArgs object =
    Object.selectionField "updateProjectColumn" [ Argument.required "input" requiredArgs.input Github.InputObject.encodeUpdateProjectColumnInput ] object (identity >> Decode.nullable)


{-| Updates the body of a pull request review.
-}
updatePullRequestReview : { input : Github.InputObject.UpdatePullRequestReviewInput } -> SelectionSet decodesTo Github.Object.UpdatePullRequestReviewPayload -> Field (Maybe decodesTo) RootMutation
updatePullRequestReview requiredArgs object =
    Object.selectionField "updatePullRequestReview" [ Argument.required "input" requiredArgs.input Github.InputObject.encodeUpdatePullRequestReviewInput ] object (identity >> Decode.nullable)


{-| Updates a pull request review comment.
-}
updatePullRequestReviewComment : { input : Github.InputObject.UpdatePullRequestReviewCommentInput } -> SelectionSet decodesTo Github.Object.UpdatePullRequestReviewCommentPayload -> Field (Maybe decodesTo) RootMutation
updatePullRequestReviewComment requiredArgs object =
    Object.selectionField "updatePullRequestReviewComment" [ Argument.required "input" requiredArgs.input Github.InputObject.encodeUpdatePullRequestReviewCommentInput ] object (identity >> Decode.nullable)


{-| Updates viewers repository subscription state.
-}
updateSubscription : { input : Github.InputObject.UpdateSubscriptionInput } -> SelectionSet decodesTo Github.Object.UpdateSubscriptionPayload -> Field (Maybe decodesTo) RootMutation
updateSubscription requiredArgs object =
    Object.selectionField "updateSubscription" [ Argument.required "input" requiredArgs.input Github.InputObject.encodeUpdateSubscriptionInput ] object (identity >> Decode.nullable)


{-| Replaces the repository's topics with the given topics.
-}
updateTopics : { input : Github.InputObject.UpdateTopicsInput } -> SelectionSet decodesTo Github.Object.UpdateTopicsPayload -> Field (Maybe decodesTo) RootMutation
updateTopics requiredArgs object =
    Object.selectionField "updateTopics" [ Argument.required "input" requiredArgs.input Github.InputObject.encodeUpdateTopicsInput ] object (identity >> Decode.nullable)
